// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::TreeBuilder;
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlTree")]
    pub struct Tree(Object<ffi::DzlTree, ffi::DzlTreeClass>) @extends gtk::TreeView, gtk::Container, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_tree_get_type(),
    }
}

impl Tree {
    pub const NONE: Option<&'static Tree> = None;
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::Tree>> Sealed for T {}
}

pub trait TreeExt: IsA<Tree> + sealed::Sealed + 'static {
    #[doc(alias = "dzl_tree_add_builder")]
    fn add_builder(&self, builder: &impl IsA<TreeBuilder>) {
        unsafe {
            ffi::dzl_tree_add_builder(
                self.as_ref().to_glib_none().0,
                builder.as_ref().to_glib_none().0,
            );
        }
    }

    //#[doc(alias = "dzl_tree_expand_to_node")]
    //fn expand_to_node(&self, node: /*Ignored*/&TreeNode) {
    //    unsafe { TODO: call ffi:dzl_tree_expand_to_node() }
    //}

    //#[doc(alias = "dzl_tree_find_child_node")]
    //fn find_child_node(&self, node: /*Ignored*/&TreeNode, find_func: /*Unimplemented*/FnMut(&Tree, /*Ignored*/TreeNode, /*Ignored*/TreeNode) -> bool, user_data: /*Unimplemented*/Option<Basic: Pointer>) -> /*Ignored*/Option<TreeNode> {
    //    unsafe { TODO: call ffi:dzl_tree_find_child_node() }
    //}

    //#[doc(alias = "dzl_tree_find_custom")]
    //fn find_custom(&self, equal_func: /*Unimplemented*/FnMut(/*Unimplemented*/Option<Basic: Pointer>) -> bool, key: /*Unimplemented*/Option<Basic: Pointer>) -> /*Ignored*/Option<TreeNode> {
    //    unsafe { TODO: call ffi:dzl_tree_find_custom() }
    //}

    //#[doc(alias = "dzl_tree_find_item")]
    //fn find_item(&self, item: Option<&impl IsA<glib::Object>>) -> /*Ignored*/Option<TreeNode> {
    //    unsafe { TODO: call ffi:dzl_tree_find_item() }
    //}

    #[doc(alias = "dzl_tree_get_context_menu")]
    #[doc(alias = "get_context_menu")]
    fn context_menu(&self) -> Option<gio::MenuModel> {
        unsafe {
            from_glib_none(ffi::dzl_tree_get_context_menu(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    //#[doc(alias = "dzl_tree_get_root")]
    //#[doc(alias = "get_root")]
    //fn root(&self) -> /*Ignored*/Option<TreeNode> {
    //    unsafe { TODO: call ffi:dzl_tree_get_root() }
    //}

    //#[doc(alias = "dzl_tree_get_selected")]
    //#[doc(alias = "get_selected")]
    //fn selected(&self) -> /*Ignored*/Option<TreeNode> {
    //    unsafe { TODO: call ffi:dzl_tree_get_selected() }
    //}

    #[doc(alias = "dzl_tree_get_show_icons")]
    #[doc(alias = "get_show_icons")]
    fn shows_icons(&self) -> bool {
        unsafe { from_glib(ffi::dzl_tree_get_show_icons(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "dzl_tree_rebuild")]
    fn rebuild(&self) {
        unsafe {
            ffi::dzl_tree_rebuild(self.as_ref().to_glib_none().0);
        }
    }

    #[doc(alias = "dzl_tree_remove_builder")]
    fn remove_builder(&self, builder: &impl IsA<TreeBuilder>) {
        unsafe {
            ffi::dzl_tree_remove_builder(
                self.as_ref().to_glib_none().0,
                builder.as_ref().to_glib_none().0,
            );
        }
    }

    //#[doc(alias = "dzl_tree_scroll_to_node")]
    //fn scroll_to_node(&self, node: /*Ignored*/&TreeNode) {
    //    unsafe { TODO: call ffi:dzl_tree_scroll_to_node() }
    //}

    #[doc(alias = "dzl_tree_set_context_menu")]
    fn set_context_menu(&self, context_menu: &impl IsA<gio::MenuModel>) {
        unsafe {
            ffi::dzl_tree_set_context_menu(
                self.as_ref().to_glib_none().0,
                context_menu.as_ref().to_glib_none().0,
            );
        }
    }

    //#[doc(alias = "dzl_tree_set_filter")]
    //fn set_filter(&self, filter_func: /*Unimplemented*/Fn(&Tree, /*Ignored*/TreeNode) -> bool, filter_data: /*Unimplemented*/Option<Basic: Pointer>) {
    //    unsafe { TODO: call ffi:dzl_tree_set_filter() }
    //}

    //#[doc(alias = "dzl_tree_set_root")]
    //fn set_root(&self, node: /*Ignored*/&TreeNode) {
    //    unsafe { TODO: call ffi:dzl_tree_set_root() }
    //}

    #[doc(alias = "dzl_tree_set_show_icons")]
    fn set_show_icons(&self, show_icons: bool) {
        unsafe {
            ffi::dzl_tree_set_show_icons(self.as_ref().to_glib_none().0, show_icons.into_glib());
        }
    }

    #[doc(alias = "dzl_tree_unselect_all")]
    fn unselect_all(&self) {
        unsafe {
            ffi::dzl_tree_unselect_all(self.as_ref().to_glib_none().0);
        }
    }

    #[doc(alias = "always-expand")]
    fn must_always_expand(&self) -> bool {
        ObjectExt::property(self.as_ref(), "always-expand")
    }

    //fn selection(&self) -> /*Ignored*/Option<TreeNode> {
    //    ObjectExt::property(self.as_ref(), "selection")
    //}

    //fn set_selection(&self, selection: /*Ignored*/Option<&TreeNode>) {
    //    ObjectExt::set_property(self.as_ref(),"selection", selection)
    //}

    #[doc(alias = "action")]
    fn connect_action<F: Fn(&Self, &str, &str, &str) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn action_trampoline<
            P: IsA<Tree>,
            F: Fn(&P, &str, &str, &str) + 'static,
        >(
            this: *mut ffi::DzlTree,
            object: *mut libc::c_char,
            p0: *mut libc::c_char,
            p1: *mut libc::c_char,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(
                Tree::from_glib_borrow(this).unsafe_cast_ref(),
                &glib::GString::from_glib_borrow(object),
                &glib::GString::from_glib_borrow(p0),
                &glib::GString::from_glib_borrow(p1),
            )
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"action\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    action_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    fn emit_action(&self, object: &str, p0: &str, p1: &str) {
        self.emit_by_name::<()>("action", &[&object, &p0, &p1]);
    }

    #[doc(alias = "populate-popup")]
    fn connect_populate_popup<F: Fn(&Self, &gtk::Widget) + 'static>(
        &self,
        f: F,
    ) -> SignalHandlerId {
        unsafe extern "C" fn populate_popup_trampoline<
            P: IsA<Tree>,
            F: Fn(&P, &gtk::Widget) + 'static,
        >(
            this: *mut ffi::DzlTree,
            object: *mut gtk::ffi::GtkWidget,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(
                Tree::from_glib_borrow(this).unsafe_cast_ref(),
                &from_glib_borrow(object),
            )
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"populate-popup\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    populate_popup_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "context-menu")]
    fn connect_context_menu_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_context_menu_trampoline<P: IsA<Tree>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlTree,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(Tree::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::context-menu\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_context_menu_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "root")]
    fn connect_root_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_root_trampoline<P: IsA<Tree>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlTree,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(Tree::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::root\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_root_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "selection")]
    fn connect_selection_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_selection_trampoline<P: IsA<Tree>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlTree,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(Tree::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::selection\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_selection_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "show-icons")]
    fn connect_show_icons_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_show_icons_trampoline<P: IsA<Tree>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlTree,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(Tree::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::show-icons\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_show_icons_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<Tree>> TreeExt for O {}

impl fmt::Display for Tree {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("Tree")
    }
}
